#include <stdio.h>

//podzadatak (a)

int provjeriBroj(int n, int *a, int *b ) {
	*a = 0; *b = 0;

	while( n % 3 == 0 ) {
		++(*a);
		n /= 3;
	}

	while( n % 5 == 0 ) {
		++(*b);
		n /= 5;
	}

	//ako su ostali *a i *b na nuli onda takvi ne postoje
	if(*a == 0 && *b == 0){
        *a = -1;
        *b = -1;
        return 0;
	}

	//inace - postoje a i b i imaju max. vrijednost
	return 1;
}

//podzadatak (b)

//pomocna funkcija - vraca 1 ako su sve znamenke broja a
//strogo vece od najvece znamenke broja b (inace vraca 0)
int pomocna(int a, int b) {
    //odredimo najvecu znamenku broja b
    int najveca = 0;
    while(b > 0){
        if(b % 10 > najveca)
            najveca = b % 10;
        b /= 10;
    }
    //provjera za sve znamenke od a da su strogo vece od znamenaka od b
    int zadovoljenUvjet = 1;
    if(a == 0)  //za a = 0 ne moze biti 0 > od najvece znamenke od b
        zadovoljenUvjet = 0;
    while (a > 0){
        if(a <= najveca) //dakle neka znamenka nije > od najvece znam. od b
            zadovoljenUvjet = 0;
        a /= 10;
    }

    return zadovoljenUvjet;
}

int izbroji(int m)
{
    int i, n, brojac = 0, a, b;
    for(i = 0; i < m; ++i){
        //ucitavamo m brojeva
        scanf("%d", &n);
        if(provjeriBroj(n, &a, &b) == 1){
            //ako postoje trazeni a i b
            //te ako a >= 2 i b >= 3
            if(a >= 2 && b >= 3)
                if(pomocna(a,b) == 1) //treba vrijediti uvjet za znamenke
                    brojac++;
        }
    }

    return brojac;
}


//ispod samo za testiranje (i to se ne ocekuje u rjesenjima)

int main(void)
{
	int m = 10;
	printf("Treba ucitati %d brojeva: ", m);
	printf("%d unesenih brojeva zadovoljava uvjete.\n", izbroji(m));

	return 0;
}
